/*
 * Book's Story — free and open-source Material You eBook reader.
 * Copyright (C) 2024-2026 Acclorite
 * SPDX-License-Identifier: GPL-3.0-only
 */

package org.dueattendant149.bookshelf.domain.use_case.history

import org.dueattendant149.bookshelf.core.log.logE
import org.dueattendant149.bookshelf.core.log.logI
import org.dueattendant149.bookshelf.domain.model.history.History
import org.dueattendant149.bookshelf.domain.repository.HistoryRepository
import javax.inject.Inject

private const val TAG = "DeleteHistory"

class DeleteHistoryUseCase @Inject constructor(
    private val historyRepository: HistoryRepository
) {

    suspend operator fun invoke(history: History) {
        logI(TAG, "Deleting history [${history.id}].")

        return historyRepository.deleteHistory(history).fold(
            onSuccess = {
                logI(TAG, "Successfully deleted history [${history.id}].")
            },
            onFailure = {
                logE(TAG, "Could not delete history [${history.id}] with error: ${it.message}")
            }
        )
    }
}